<script setup lang="ts">
import { RouterLink } from 'vue-router'
import { reactive } from 'vue'
import { useManagerStore } from '@/stores/manager';
import axios from 'axios';
import { useCreatedCustomerStore } from '@/stores/customer.craetion';
import { useSessionStore } from '@/stores/jsession.cookie';
import { storeToRefs } from 'pinia';
import { ElMessage } from 'element-plus'
import router from '@/router';


const managerState = useManagerStore();
const createdCustomerStore = useCreatedCustomerStore();
const sessionStore = useSessionStore();
const isJsessionSet = storeToRefs(sessionStore).isJSessionIDSet;
const form = reactive({
  "name": null,
  "telephone": null,
  "website": null,
  "creatorId": "",
  "modifierId": ""
})

const logout = async () => {
  try {
    const response = await axios.post('http://localhost:8080/logout');
    if (response.status === 200) {
      ElMessage({
        type: 'success',
        message: 'ログアウト成功しました',
      });
      sessionStore.updateIsJSessionIDSet()
      await router.push("/")
      location.reload();
    }
  } catch (error) {
    console.error('Error during logout:', error);
  }
};

const onSubmit = async () => {
  try {
    form.creatorId = managerState.currentCustomerManagerId;
    form.modifierId = managerState.currentCustomerManagerId;
    const response = await axios.post('http://localhost:8080/api/v1/customers', form, {
      headers: {
        'accept': '*/*',
        'Content-Type': 'application/json',
      }, withCredentials: true
    });
    createdCustomerStore.setCustomerId(response.data);
    form.name = null;
    form.telephone = null;
    form.website = null;
    ElMessage({
      type: 'success',
      message: '保存に成功しました',
    });
  } catch (error) {
    console.error('Error while submitting the form:', error);
    ElMessage({
      type: 'error',
      message: '保存に失敗しました',
    });
  }
}

</script>

<template>
  <div class="common-layout">
    <el-container>
      <el-aside width="152px" class="border" style="overflow-x: hidden; overflow-y: hidden;">
        <div class="simple-form-border">
          <h3 style="margin-left: 10px;">取引先担当者</h3>
          <span style="font-size: 12px; margin-left: 10px; margin-bottom: 10px; font-weight: bold;">ID: {{
            managerState.currentCustomerManagerId }}</span>
          <br>
          <span style="font-size: 12px; margin-left: 10px; margin-bottom: 10px;font-weight: bold;">名前: {{
            managerState.currentCustomerManagerName }}</span>
        </div>

        <el-dropdown style="margin-bottom: 10px; margin-left: 10px;">
          <el-button type="primary" plain size="small" :disabled="!isJsessionSet">
            新規作成
            <el-icon class="el-icon--right"><arrow-down /></el-icon>
          </el-button>
          <template #dropdown>
            <el-dropdown-menu>
              <el-dropdown-item>新規取引先</el-dropdown-item>
              <el-dropdown-item>新規取引先担当者</el-dropdown-item>
            </el-dropdown-menu>
          </template>
        </el-dropdown>
        <el-dropdown style="margin-bottom: 10px;margin-left: 10px;">
          <el-button type="primary" plain size="small" :disabled="!isJsessionSet">
            最近使ったデータ
            <el-icon class="el-icon--right"><arrow-down /></el-icon>
          </el-button>
          <template #dropdown>
            <el-dropdown-menu>
              <el-dropdown-item> On-hover Dynamic Item</el-dropdown-item>
            </el-dropdown-menu>
          </template>
        </el-dropdown>
        <div class="simple-form-border">
          <h3 style="margin-left: 10px; margin-bottom: 10px;">簡易作成</h3>
          <el-form :model="form" label-width="80px" size="small" label-position="top">
            <el-form-item class="custom-el-form-margin" label="取引先名" :rules="[
              {
                required: true,
                message: 'Please input 取引先名',
                trigger: 'blur',
              }
            ]">
              <el-input class="custom-el-input-width" v-model="form.name" />
            </el-form-item>
            <el-form-item class="custom-el-form-margin" label="電話">
              <el-input class="custom-el-input-width" v-model="form.telephone" />
            </el-form-item>
            <el-form-item class="custom-el-form-margin" label="Web サイト">
              <el-input class="custom-el-input-width" v-model="form.website" />
            </el-form-item>
          </el-form>
          <el-button type="primary" plain size="small" @click="onSubmit" class="custom-el-form-simple-button"
            :disabled="!isJsessionSet">保存</el-button>
        </div>
        <el-button type="danger" size="small" @click="logout" style="margin-left: 10px; margin-bottom: 10px;">Logout</el-button>

      </el-aside>
      <el-main class="border">
        <div class="common-layout">
          <el-container>
            <nav>
              <RouterLink to="/">ホーム</RouterLink>
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/customer/portal">取引先
              </RouterLink>
              <!-- Implemented, not rendered as a web page (取引先担当者 data used for 取引先機能) -->
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">取引先担当者</RouterLink>
              <!-- Not implemented as not specified in documentation -->
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">スタッフ</RouterLink>
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">商談</RouterLink>
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">契約</RouterLink>
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">リード</RouterLink>
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">レポート</RouterLink>
              <RouterLink :class="{ 'disabled-link': !isJsessionSet }" to="/">+</RouterLink>
            </nav>
          </el-container>
          <el-main>
            <RouterView></RouterView>
          </el-main>
        </div>
      </el-main>
    </el-container>
  </div>
</template>

<style>
.menu-margin {
  margin: 10px 10px 10px 5px;
}

nav {
  text-align: left;
  margin-left: -1rem;
  margin-top: -1rem;
  font-size: 1rem;
}

nav a.router-link-exact-active {
  color: var(--color-text);
}

nav a.router-link-exact-active:hover {
  background-color: transparent;
}

nav a {
  display: inline-block;
  padding: 0 1rem;
  border: 2px solid hsl(2, 48%, 53%);
  border-right: none;

}

nav a:last-child {
  border: 2px solid hsl(2, 48%, 53%);
}

.border {
  border: 2px solid hsl(213, 42%, 38%);
  border-top: none;
}

.border:first-child {
  border: 2px solid hsl(213, 42%, 38%);
  border-top: none;
  border-right: none;
}

.no-scrollbar {
  overflow-x: hidden;
  overflow-y: hidden;
}

.custom-el-input-width {
  width: 120px;
  margin-left: 10px;
}

.custom-el-form-margin {
  margin-left: 10px;
}

.custom-el-form-simple-button {
  margin-left: 55px;
  margin-bottom: 10px;
}

.simple-form-border {
  border-top: 1px solid hsl(213, 42%, 38%) !important;
  border-bottom: 1px solid hsl(213, 42%, 38%) !important;
  margin-bottom: 10px;
}

.simple-form-border:first-of-type {
  border-bottom: 1px solid hsl(213, 42%, 38%) !important;
  margin-bottom: 10px;
}

nav a.disabled-link {
  pointer-events: none;
  color: #ccc;
}
</style>

